
(* Practica 2. Laboratorio de programacion II
   Marzo de 2000                                *)

MODULE Laberint;
FROM IO IMPORT WrStr,RdKey,WrChar,WrLn;
FROM Window IMPORT Clear;

CONST
    MAXX=5;
    MAXY=5;
TYPE
   TCasilla = RECORD
                   paso,visitado,salida:BOOLEAN;
              END;
   TLaberinto = ARRAY [1..MAXX],[1..MAXY] OF TCasilla;

VAR
  l:TLaberinto;
  salida:BOOLEAN;

PROCEDURE Inicializa(VAR l:TLaberinto);
VAR
  x,y:CARDINAL;
  tecla:CHAR;
BEGIN

  FOR y:=1 TO MAXY DO
      FOR x:=1 TO MAXX DO
          l[x][y].visitado:=FALSE;
          l[x][y].salida:=FALSE;
          tecla:=RdKey();
          l[x][y].paso:=CAP(tecla)<>'X';
          IF l[x][y].paso THEN
             WrChar(' ');
          ELSE
             WrChar('X');
          END;
      END;
      WrLn;
  END;
END Inicializa;

PROCEDURE Pinta(l:TLaberinto);
VAR
  x,y:CARDINAL;
BEGIN
  FOR y:=1 TO MAXY DO
      FOR x:=1 TO MAXX DO
          IF l[x][y].paso THEN
             IF l[x][y].salida THEN
                WrChar('.');
             ELSE
                WrChar(' ');
             END;
          ELSE
             WrChar('X');
          END;
      END;
      WrLn;
  END;
END Pinta;

PROCEDURE BuscaSalida(VAR l:TLaberinto;x0,y0,xf,yf:CARDINAL;
                      VAR salida:BOOLEAN);
BEGIN
  (* Casos base *)
    IF (x0<1) OR (x0>MAXX) OR (y0<1) OR (y0>MAXY) OR
       (NOT (l[x0][y0].paso)) OR (l[x0][y0].visitado) THEN
       salida:=FALSE;
    ELSE
  (* Caso base tambien *)
       IF (x0=xf) AND (y0=yf) THEN
          l[x0][y0].salida:=l[x0][y0].paso;
          salida:=l[x0][y0].salida;
       ELSE
  (* Parte recursiva *)
          l[x0][y0].visitado:=TRUE;
          BuscaSalida(l,x0,y0+1,xf,yf,salida);
          IF (NOT salida) THEN
             BuscaSalida(l,x0+1,y0,xf,yf,salida);
                IF (NOT salida) THEN
                   BuscaSalida(l,x0-1,y0,xf,yf,salida);
                      IF (NOT salida) THEN
                         BuscaSalida(l,x0,y0-1,xf,yf,salida);
                      END;
                END;
          END;
          l[x0][y0].salida:=salida;
       END;
    END;
END BuscaSalida;

BEGIN
    Inicializa(l);
    Clear();
    BuscaSalida(l,1,1,MAXX,MAXY,salida);
    IF salida THEN
       WrStr("SALIDA ENCONTRADA !! ");
       WrLn;
    ELSE
       WrStr("NO HAY SALIDA !! ");
    END;
    Pinta(l);
END Laberint.

